%{
#undef YY_INPUT
#define YY_INPUT(b,r,ms) (r=str_yyinput(b,ms))

#include <stdio.h>
%}

Digit                   [0-9]
Letter                  [A-Za-z]
Filename                ({Letter}|{Digit}|"_"|".")+

%x FNAME
%x FLAG

%%

%{
/* This is the init part of the yylex()    */
/* White space and EOL is important to lex */

%}

[ ]+               ;

-h                 |
-help              { 
                     printf("The following are help info ......\n\n");
                     return 1;
                   }

-v                 {
                     printf("verbose mode is on\n");
                   }

-o                 {
                     BEGIN FNAME;
                   }

{Filename}".hpf"   {
                     printf("use file %s\n", yytext); 
                     return 1;;     
                   }

.                  { 
                     printf("Usage: hpff [-v] [-o output_filename] filename.hpf\n"
                            "   Or: hpff [-help | -h] \n");
  
                     return 1;
                   }

<FNAME>[ ]+        ;

<FNAME>{Filename}  {
                     printf("ouput file %s\n", yytext); 
                     BEGIN INITIAL;     
                   }

<FNAME>.           { 
                     printf("Error: missing output file name\n");
                     return 1;
                   }


%%
/*  Function and Varibles used as FLEX input;  */  

# include <memory.h>

char * str_buf_head;
char * str_buf_end;

int str_yyinput(char * buf, int max_size)
{
  int n;
  n=((max_size)<(str_buf_end-str_buf_head)?(max_size):(str_buf_end-str_buf_head));
  if (n>0) {
    memcpy(buf, str_buf_head, n);
    str_buf_head += n;
  }
  return n;
}







